// Code generated by "enumer -type=RowInclusionType -json -text -yaml"; DO NOT EDIT.

//
package rowInclusionTypes

import (
	"encoding/json"
	"fmt"
)

const _RowInclusionTypeName = "BothHtmlOnlyPdfOnly"

var _RowInclusionTypeIndex = [...]uint8{0, 4, 12, 19}

func (i RowInclusionType) String() string {
	if i < 0 || i >= RowInclusionType(len(_RowInclusionTypeIndex)-1) {
		return fmt.Sprintf("RowInclusionType(%d)", i)
	}
	return _RowInclusionTypeName[_RowInclusionTypeIndex[i]:_RowInclusionTypeIndex[i+1]]
}

var _RowInclusionTypeValues = []RowInclusionType{0, 1, 2}

var _RowInclusionTypeNameToValueMap = map[string]RowInclusionType{
	_RowInclusionTypeName[0:4]:   0,
	_RowInclusionTypeName[4:12]:  1,
	_RowInclusionTypeName[12:19]: 2,
}

// RowInclusionTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func RowInclusionTypeString(s string) (RowInclusionType, error) {
	if val, ok := _RowInclusionTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to RowInclusionType values", s)
}

// RowInclusionTypeValues returns all values of the enum
func RowInclusionTypeValues() []RowInclusionType {
	return _RowInclusionTypeValues
}

// IsARowInclusionType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i RowInclusionType) IsARowInclusionType() bool {
	for _, v := range _RowInclusionTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for RowInclusionType
func (i RowInclusionType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for RowInclusionType
func (i *RowInclusionType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("RowInclusionType should be a string, got %s", data)
	}

	var err error
	*i, err = RowInclusionTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for RowInclusionType
func (i RowInclusionType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for RowInclusionType
func (i *RowInclusionType) UnmarshalText(text []byte) error {
	var err error
	*i, err = RowInclusionTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for RowInclusionType
func (i RowInclusionType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for RowInclusionType
func (i *RowInclusionType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = RowInclusionTypeString(s)
	return err
}
